<script setup lang="ts">
    import { computed, onMounted, ref, watch } from "vue";
    import { Line, LineDataExport, PhotoMetaExport } from "../functions/types";
    import { addLineToMap, addPhotoMarkerToMap, clearLinesFromMap, initMap, lineDataExportToLines } from "../functions/map";
    import seedrandom from "seed-random";
    import OverEverythingLayer from "./OverEverythingLayer.vue";
    import PhotoDisplayApplication from "./PhotoDisplayApplication.vue";
    import { VSlider } from "vuetify/components";
    import { Coordinate } from "ol/coordinate";

    const photoDisplayMode = ref(false);
    const photoDisplayId = ref(0);

    const sliderState = ref(1.0);

    const props = defineProps<{
        dataPoints: LineDataExport;
        photosMeta: PhotoMetaExport;
        wayPointsArr: { key: string; coords: Coordinate[][] }[];
        password: string;
    }>();

    const timestamps = computed(() => {
        return [
            ...props.dataPoints.map((point) => {
                return point[1]; // timestamp
            }),
            ...props.photosMeta.map((photo) => {
                return photo[1]; // timestamp
            }),
        ];
    });
    const datetimeFrom = computed(() => {
        return Math.min(...timestamps.value);
    });
    const datetimeTo = computed(() => {
        return Math.max(...timestamps.value);
    });

    const effectiveDatetimeTo = computed(() => {
        const diff = Math.max(datetimeTo.value - datetimeFrom.value, 1);

        return Math.floor(sliderState.value * diff) + datetimeFrom.value;
    });

    watch(
        () => [props.dataPoints, props.photosMeta, props.wayPointsArr, effectiveDatetimeTo],
        () => {
            redrawLines();
        },
        {
            deep: true,
        }
    );

    onMounted(() => {
        initMap();
    });

    function redrawLines() {
        clearLinesFromMap();

        // filter for real timestamps
        const dataPoints = props.dataPoints.filter((point) => {
            const timeStamp = point[1]; // timestamp

            return datetimeFrom.value <= timeStamp && effectiveDatetimeTo.value >= timeStamp;
        });
        const photosMeta = props.photosMeta.filter((photo) => {
            const timeStamp = photo[1]; // timestamp

            return datetimeFrom.value <= timeStamp && effectiveDatetimeTo.value >= timeStamp;
        });

        lineDataExportToLines(dataPoints).forEach((line) => {
            if (line.length > 1) {
                addLineToMap(line, 3, generateRandomColor(String(line[0][0]) + String(line[0][1])));
            }
        });

        photosMeta.forEach((photo) => {
            addPhotoMarkerToMap(photo, (id: number) => {
                photoDisplayId.value = id;
                photoDisplayMode.value = true;
            });
        });

        props.wayPointsArr.forEach((ways) => {
            const color = generateRandomColor(ways.key);
            ways.coords.forEach((way) => {
                addLineToMap(way as Line, 4, color, true);
            });
        });
    }

    function generateRandomColor(seed: string): [number, number, number, number] {
        const rng = seedrandom(seed);

        const darkerFactor = 0.75;
        const randomR = Math.floor(rng() * 256 * darkerFactor);
        const randomG = Math.floor(rng() * 256 * darkerFactor);
        const randomB = Math.floor(rng() * 256 * darkerFactor);
        const alpha = 0.8;

        return [randomR, randomG, randomB, alpha];
    }

    function timeConverter(UNIX_timestamp: number) {
        var a = new Date(UNIX_timestamp);
        var month = a.getMonth() + 1;
        var date = a.getDate();
        var year = a.getFullYear();
        var hour = a.getHours();
        var min = a.getMinutes();

        if (isNaN(month)) {
            return "Keine Punkte";
        }

        var time = hour + ":" + min + " " + date + "." + month + "." + year;
        return time;
    }
</script>

<template>
    <v-row class="mx-2">
        <v-slider class="v-col-12 mx-0" v-model="sliderState" :max="1" :min="0" :step="0.005" thumb-label="always">
            <template v-slot:thumb-label="{}"><pre v-html="timeConverter(effectiveDatetimeTo)"></pre></template
        ></v-slider>
    </v-row>

    <div id="map"></div>

    <over-everything-layer v-if="photoDisplayMode">
        <photo-display-application
            @close-photo-application="photoDisplayMode = false"
            :display-id="photoDisplayId"
            :password="password"
        >
        </photo-display-application>
    </over-everything-layer>
</template>

<style scoped></style>
